

/****** Object : Table [dbo].[EventID] Copyright TECK SYSTEM SOFT 2024 One ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Insert_Date] = '' WHERE [Insert_Date] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Customer] = '' WHERE [Customer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Manager] = '' WHERE [Manager] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Severity] = '' WHERE [Severity] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Domain] = '' WHERE [Domain] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Computer] = '' WHERE [Computer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [LogName] = '' WHERE [LogName] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Source] = '' WHERE [Source] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [EventLevel] = '' WHERE [EventLevel] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Eventid] = '' WHERE [Eventid] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Status] = '' WHERE [Status] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Mode] = '' WHERE [Mode] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Alarm] = '' WHERE [Alarm] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] SET [Availability] = '' WHERE [Availability] IS NULL

 INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityEventID]
([Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[LogName]
	  ,[Source]
	  ,[EventLevel]
	  ,[Eventid]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
	  ,[Availability]
)

SELECT  
[Insert_Date]
       ,[Customer]
       ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain] 
      ,[Computer]
      ,[LogName]
	  ,[Source]
	  ,[EventLevel]
	  ,[Eventid]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
	  ,CONVERT(nvarchar(25),[Availability])
	  
FROM
(SELECT DISTINCT  CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [LogName] +  '-' + [Source] + '-' + [Eventlevel] + '-' + [Eventid] + '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING
	  ,[Insert_Date] 
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[LogName]
	  ,[Source]
	  ,[EventLevel]
	  ,[Eventid]
      ,[Status] 
      ,[Mode]
      ,[Alarm]
      ,[Availability] 

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID]
WHERE [Availability] = '1' AND CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [LogName] +  '-' + [Source] + '-' + [Eventlevel] + '-' + [Eventid] + '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability]) NOT IN 

(SELECT DISTINCT  CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [LogName] +  '-' + [Source] + '-' + [Eventlevel] + '-' + [Eventid] + '-' + [Status] + '-' + [Alarm]  + '-' + CONVERT(nvarchar(10),[Availability]) AS SEARCH_STRING
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityEventID]) ) TBL 
WHERE [Availability] = 1
/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityEventID] 
SET  [Status] = REQUEST.[Status],
     [Alarm] = REQUEST.[Alarm],
     [Availability] = REQUEST.[Availability]
     /*[Insert_Date] = REQUEST.[Insert_Date] -- Last UPDATE time */

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityEventID] EVTS,

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Event_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[LogName],
TEMP_JOIN.[Source],
TEMP_JOIN.[EventLevel],
TEMP_JOIN.[Eventid],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] TEMP
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] TEMP_JOIN 
ON TEMP_JOIN.[Mode] = TEMP.[Mode]

WHERE 
TEMP.[Customer] = TEMP_JOIN .[Customer] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND
TEMP.[Domain] = TEMP_JOIN .[Domain] AND
TEMP.[Computer] = TEMP_JOIN .[Computer] AND
TEMP.[LogName] =  TEMP_JOIN .[LogName] AND
TEMP.[Source] =  TEMP_JOIN .[Source] AND
TEMP.[EventLevel] =  TEMP_JOIN .[EventLevel] AND
TEMP.[Eventid] =  TEMP_JOIN .[Eventid] AND
TEMP.[Mode] = TEMP_JOIN .[Mode] AND
TEMP.[Status] = TEMP_JOIN .[Status]AND
TEMP.[Alarm] = TEMP_JOIN .[Alarm] AND
TEMP.[Availability]=TEMP_JOIN.[Availability]
GROUP BY
TEMP_JOIN.[Event_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[LogName],
TEMP_JOIN.[Source],
TEMP_JOIN.[EventLevel],
TEMP_JOIN.[Eventid],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

HAVING max(TEMP.Event_ID) = TEMP_JOIN.[Event_ID]) AS REQUEST

WHERE
EVTS.[Customer] = REQUEST.[Customer]
AND EVTS.[Site] = REQUEST.[Site]
AND EVTS.[Domain] = REQUEST.[Domain]
AND EVTS.[Computer] = REQUEST.[Computer]
AND EVTS.[Alarm] = REQUEST.[Alarm]
AND EVTS.[Status] = REQUEST.[Status]
AND EVTS.Availability = REQUEST.Availability
   
TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp]