

/****** Object : Table [dbo].[EventTemp] Copyright TECK SYSTEM SOFT 2015 TB Source ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Customer] = '' WHERE [Customer] IS NULL  /* Source */
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Manager] = '' WHERE [Manager] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Severity] = '' WHERE [Severity] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Domain] = '' WHERE [Domain] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Computer] = '' WHERE [Computer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [LogName] = '' WHERE [LogName] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Source] = '' WHERE [Source] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [EventLevel] = '' WHERE [EventLevel] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Eventid] = '' WHERE [Eventid] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Status] = '' WHERE [Status] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Mode] = '' WHERE [Mode] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Alarm] = '' WHERE [Alarm] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] SET [Availability] = '' WHERE [Availability] IS NULL

 INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID]  /* Target */
([Insert_Date]
	 ,[Start_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[LogName]
      ,[Source]
      ,[EventLevel]
      ,[Eventid]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
      ,[Availability]
)
SELECT  
GETDATE()
     ,GETDATE() 
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain] 
      ,[Computer]
      ,[LogName]
      ,[Source]
      ,[EventLevel]
      ,[Eventid]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
	  ,CONVERT(nvarchar(10),[Availability]) 

FROM

(SELECT DISTINCT [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [LogName] +  '-' + [Source] + '-' + [EventLevel] +  '-' + [Eventid]+  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING
	   /*,[Insert_Date] Add for test purpose only */
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[LogName]
      ,[Source]
      ,[EventLevel]
      ,[Eventid]
      ,[Status] 
      ,[Mode]
      ,[Alarm]
	  ,[Availability] 

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] /* Source */
WHERE [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [LogName] +  '-' + [Source] + '-' + [EventLevel]+  '-' + [Eventid]+  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  NOT IN 

(SELECT DISTINCT  [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [LogName] +  '-' + [Source] + '-' + [EventLevel] +  '-' + [Eventid]+  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID]) ) TBL  /* Target */

/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] /* Target */
SET  [Status] = REQUEST.[Status],
     [Alarm] = REQUEST.[Alarm],
     [Availability] = REQUEST.[Availability],
     [Insert_Date] = REQUEST.[Insert_Date] -- Last UPDATE time

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[EventID] PROCS, /* Target */

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Event_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[LogName],
TEMP_JOIN.[Source],
TEMP_JOIN.[EventLevel],
TEMP_JOIN.[Eventid],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] TEMP /* Source */
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] TEMP_JOIN  /* Source */
ON TEMP_JOIN.[Mode] = TEMP.[Mode]

WHERE 
TEMP.[Customer] = TEMP_JOIN .[Customer] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND
TEMP.[Domain] = TEMP_JOIN .[Domain] AND
TEMP.[Computer] = TEMP_JOIN .[Computer] AND
TEMP.[LogName] =  TEMP_JOIN .[LogName] AND
TEMP.[Source] =  TEMP_JOIN .[Source] AND
TEMP.[EventLevel] =  TEMP_JOIN .[EventLevel] AND
TEMP.[Eventid] =  TEMP_JOIN .[Eventid] AND
TEMP.[Mode] = TEMP_JOIN .[Mode] AND
TEMP.[Status] = TEMP_JOIN .[Status]AND
TEMP.[Alarm] = TEMP_JOIN .[Alarm] AND
TEMP.[Availability]=TEMP_JOIN.[Availability]

GROUP BY
TEMP_JOIN.[Event_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[LogName],
TEMP_JOIN.[Source],
TEMP_JOIN.[EventLevel],
TEMP_JOIN.[Eventid],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

HAVING max(TEMP.Event_ID) = TEMP_JOIN.[Event_ID]) AS REQUEST

WHERE
    PROCS.[Customer] = REQUEST.[Customer]
AND PROCS.[Site] = REQUEST.[Site]
AND PROCS.[Domain] = REQUEST.[Domain]
AND PROCS.[Computer] = REQUEST.[Computer]
AND PROCS.[Alarm] = REQUEST.[Alarm]
AND PROCS.[Availability] = REQUEST.[Availability]
AND PROCS.[Status] = REQUEST.[Status]

/****** Object : Clean Temporary SQL Table ******/

 /* TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[EventTemp] */
